// CONEXION CON UNA BD DE ACCESS USANDO EL PUENTE JDBC:ODBC
// REGISTRANDO LA BD EN EL PANEL DE CONTROL ODBC DE 32 BITS CON EL NOMBRE BD1
//
// LA BD Access-jdbc.mdb TIENE UNA TABLA QUE SE LLAMA Tabla1
// CON 3 COLUMNAS: Id, Nombre y Telefono.
// LOS REGISTROS SE MUESTRAN EN JTextArea INCLUIDA EN JScrollPane PARA TENER BARRAS DE SCROLL

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.sql.*;
import java.awt.Component;
import java.awt.Color.*;
import java.io.File;

//import java.sql.Connection;
//import java.sql.DriverManager;

// CLASE PRINCIPAL DEL PROGRAMA
public class jdbc_access2 extends JFrame {

  // variables a nivel de clase
  private jdbc_access2 ventana;
  private JPanel p1;
  private JPanel p2;
  private JPanel p3;
  private JLabel titulo;
  private JLabel info;
  private JLabel bd;
  private JButton conect;
  private JButton descon;
  private JButton exit;
  private String url, db;
  private Connection con;
  private JTextArea texto;

  // METODO PRINCIPAL, DE ENTRADA AL PROGRAMA
  public static void main(String args[]) {
	  try
	  {
		 // Java look and feel
    	JFrame.setDefaultLookAndFeelDecorated(true);
		// instancia de la clase principal
		new jdbc_access2();
	  }
	catch (Exception pollo) {
		// cuadro de mensaje con informacion sobre el error
		JOptionPane.showMessageDialog(null,pollo.getMessage(),"Error",JOptionPane.INFORMATION_MESSAGE); 
		//JOptionPane.showMessageDialog(null,"Ha fallado el m\u00e9todo Main().","Error",JOptionPane.INFORMATION_MESSAGE);
		}
	}

	// METODO CONSTRUCTOR QUE CREA Y MUESTRA LA INTERFAZ
  public jdbc_access2() {

		/* la variable especial super refiere a la superclase de la clase actual,
		* la clase Jdbc_sql hereda de JFrame por ello
		* super es JFrame, se declara un JFrame con el constructor
		* que pasa como argumento un String para el titulo,
		* super ha de ir siempre en la primera linea del metodo */
		super("JDBC Access");
		/* la linea anterior equivale a this.setTitle("JDBC Access");
		* cualquiera de las dos sirve para mostrar el texto
		* en la barra de titulo de la ventana */

	  try
	  {

		/* la variable especial this se usa en metodos de instancia
		* para hacer referencia al objeto que contiene al metodo,
		* aqui equivale a JFrame */

		// accion por defecto al cerrar la ventana: salir del programa
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		//paneles para la disposicion de elementos
		p1 = new JPanel(new BorderLayout()); //panel principal, ocupa todo el marco
		p2 = new JPanel(new GridLayout(1, 3, 6, 6)); // panel inferior para BorderLayout.SOUTH
		p1.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		//p3 = new JPanel(new GridLayout(3, 1)); //panel medio para BorderLayout.CENTER
		//p3.setBorder(BorderFactory.createEmptyBorder(8,8,8,8));
		p3 = new JPanel(new BorderLayout()); //panel medio para BorderLayout.CENTER
		p3.setBorder(BorderFactory.createEmptyBorder(10,10,20,20));

		texto = new JTextArea();
		//contenedor para mostrar las barras de scroll
		JScrollPane pScroll = new JScrollPane(texto, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		texto.setEditable(false);
		texto.setFont(new java.awt.Font("Tahoma", Font.PLAIN, 14));
		texto.setText("");

		conect = new JButton("Conectar");
		descon = new JButton("Desconectar");
		exit = new JButton("Salir");

		//alineacion del texto en las etiquetas
		titulo = new JLabel("Puente JDBC:ODBC [Access]", SwingConstants.CENTER);
		info = new JLabel("Desconectado", SwingConstants.CENTER);
		bd = new JLabel("Registros: 0", SwingConstants.CENTER);
		titulo.setVerticalAlignment(SwingConstants.CENTER);
		info.setVerticalAlignment(SwingConstants.CENTER);
		bd.setVerticalAlignment(SwingConstants.CENTER);

		//asociar los botones con instancias de las clases que definen las acciones
		this.exit.addActionListener(new accionSalir());
		this.conect.addActionListener(new accionConectar());
		this.descon.addActionListener(new accionDesconectar());

		Font letra1 = new Font("Tahoma", Font.BOLD, 18);
		Font letra2 = new Font("Tahoma", Font.PLAIN, 14);
		Font letra3 = new Font("Tahoma", Font.BOLD, 14);
		titulo.setFont(letra1);
		info.setFont(letra2);
		bd.setFont(letra2);
		conect.setFont(letra2);
		descon.setFont(letra2);
		exit.setFont(letra2);
		info.setForeground(Color.blue);
		bd.setForeground(Color.blue);

		p1.add(titulo, BorderLayout.NORTH);
		p1.add(p2, BorderLayout.SOUTH);
		p1.add(p3, BorderLayout.CENTER);
		p3.add(info, BorderLayout.NORTH);
		p3.add(pScroll, BorderLayout.CENTER);
		p3.add(bd, BorderLayout.SOUTH);
		p2.add(conect);
		p2.add(descon);
		p2.add(exit);

		// tooltip en botones
		conect.setToolTipText("Conectar con la base de datos");
		descon.setToolTipText("Desconectar de la base de datos");
		exit.setToolTipText("Salir del programa");
		
		// crear y mostrar la ventana
		this.getContentPane().add(p1);
		this.setSize(460, 420);
		this.setLocationRelativeTo(null); // centrar el formulario en la pantalla
		this.setResizable(false);
		//this.setTitle("JDBC Access");
		this.setVisible(true);
		}

	 catch (Exception pollo) {
		// cuadro de mensaje con informacion sobre el error
		JOptionPane.showMessageDialog(null,pollo.getMessage(),"Error",JOptionPane.INFORMATION_MESSAGE); 
		//JOptionPane.showMessageDialog(null,"Ha fallado el m\u00e9todo crearTodo().","Error",JOptionPane.INFORMATION_MESSAGE);
		}
  }

	/* CONECTAR CON LA BD Y MOSTRAR INFORMACION,
	* el boton conect se asocia con una instancia de la clase accionConectar,
	* en la clase accionConectar estan definidos el evento y la accion que se va a realizar */
class accionConectar
      implements ActionListener {
    public void actionPerformed(ActionEvent evt) {

		// ruta fisica a la base de datos, en la conexion se utiliza el nombre asignado en el panel de ODBC
		//String db = "D:\\Java\\_Pendientes\\Jdbc-Odbc\\conectar\\AccessBD_1.mdb";
		// nombre del archivo .mdb
		String db = "Access-jdbc.mdb";

		// obtener la ruta absoluta a la carpeta de trabajo del proyecto para ello
		// se emplea el truco de crear un archivo nuevo refiriendonos al fichero
		// simbolico . y luego recoger sus caracteristicas, el fichero . hace referencia
		// al directorio actual por lo que leyendo dicho fichero podemos pedir su ruta
		String ruta = new File(".").getAbsolutePath();
		// getAbsolutePath devuelve la ruta a la carpeta pero agrega un punto al final
		// quitamos ese ultimo caracter con substring y length
		ruta = ruta.substring(0, ruta.length()-1);
		// subir 2 veces en el arbol de directorios para llegar a la carpeta con la base de datos
		ruta=ruta.substring(0, ruta.lastIndexOf(File.separator));
		ruta=ruta.substring(0, ruta.lastIndexOf(File.separator));
		// agregar el nombre de la base de datos al final de la ruta obtenida
		ruta = ruta + File.separator + db;

		// cadena de conexion que utiliza el nombre asignado en el panel DNS
		// Importante: hay que usar el panel de configuracion ODBC de Windows de 32 bits
		// junto con la version de Java 7 de 32 bits, si Java es de 64 bits el puente no llega a funcionar
		String url = "jdbc:odbc:BD1";
		// otras cadenas que no funcionan
		//String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=" + db + ";DriverID=22;READONLY=true";
		//String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=" + db;
		//String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb,*.accdb)};DBQ=" + db + ";DriverID=22;READONLY=true";
		//String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb,*.accdb)};DBQ=" + db;

	 try {
 		// registrar el driver JDBC usando el cargador de clases Class.forName
       Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        con = DriverManager.getConnection(url, "", "");
		// consultas de seleccion SQL
        Statement sql1 = con.createStatement();
		Statement sql2 = con.createStatement();
		/* ResultSet para almacenar registros devueltos por la consulta,
		* la interfaz ResultSet representa un conjunto de datos resultado de una consulta SQL
		* para acceder a los registros se emplea un cursor que inicialmente apunta antes del primer registro
		* para avanzar por los registros se emplea el metodo ResultSet.next() */
		ResultSet select1 = sql1.executeQuery("SELECT COUNT(Id) AS Contador FROM Tabla1");
		// mientras ResultSet tenga registros
        while (select1.next()) {
			// informar del numero de registros
			info.setText(ruta);
			bd.setText("Registros: " + select1.getInt("Contador"));
		  }
		texto.setText("");
		// ResultSet para almacenar registros devueltos por la consulta
		ResultSet select2 = sql2.executeQuery("SELECT * FROM Tabla1 ORDER BY Id");
		// mientras ResultSet tenga registros
		while (select2.next()) 	{
			// rellenar JTextArea con los registros devueltos por la consulta
			String aux = new String (select2.getString("Id") + " - "); // mostrar la columna ID
			aux += select2.getString("Nombre") + " ("; // mostrar la columna Nombre
			aux += select2.getString("Telefono") + ")\n"; // mostrar la columna Telefono y salto de linea
			texto.append (aux); } // agregar lineas al control JTextArea
			texto.setCaretPosition(0); //cursor al principio del texto
			//texto.setCaretPosition(texto.getDocument().getLength()); //cursor al final del texto

			//liberar recursos
			select1.close();
			sql1.close();
			select2.close();
			sql2.close();
			con.close();
		}

      catch (Exception pollo) {
        info.setText("Ha fallado la conexi\u00f3n");
        bd.setText("Registros: 0");
		texto.setText("");
		// cuadro de mensaje con informacion sobre el error
		JOptionPane.showMessageDialog(null,pollo.getMessage(),"Error",JOptionPane.INFORMATION_MESSAGE); 
		//JOptionPane.showMessageDialog(null,"Ha fallado el m\u00e9todo accionConectar().","Error",JOptionPane.INFORMATION_MESSAGE);
		}
   }
}

	/* DESCONECTAR DE LA BD,
	* el boton descon se asocia con una instancia de la clase accionDesconectar,
	* en la clase accionDesconectar estan definidos el evento y la accion que se va a realizar */
  class accionDesconectar
      implements ActionListener {
    public void actionPerformed(ActionEvent evt) {
      try {
		  // si la conexion esta abierta todavia, cerrarla
		if (con != null)     
            con.close();    
        info.setText("Desconectado");
        bd.setText("Registros: 0");
		texto.setText("");
      }
      catch (Exception pollo) {
        info.setText("Ha fallado la desconexi\u00f3n");
		// cuadro de mensaje con informacion sobre el error
		JOptionPane.showMessageDialog(null,pollo.getMessage(),"Error",JOptionPane.INFORMATION_MESSAGE); 
		//JOptionPane.showMessageDialog(null,"Ha fallado el m\u00e9todo accionDesconectar().","Error",JOptionPane.INFORMATION_MESSAGE); 
	  }
    }
  }

	/* CERRAR EL PROGRAMA AL PULSAR EL BOTN exit
    * el boton exit se asocia con una instancia de la clase accionBoton,
    * en la clase accionBoton estan definidos el evento y la accion que se va a realizar */
  class accionSalir
      implements ActionListener {
    public void actionPerformed(ActionEvent evt) {
      System.exit(0); }
  }

}
